/* -*- indent-tabs-mode: nil; js-indent-level: 2 -*- */
/* This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this
 * file, You can obtain one at http://mozilla.org/MPL/2.0/. */

const {classes: Cc, interfaces: Ci, utils: Cu} = Components;

Cu.import("resource://gre/modules/Preferences.jsm");
Cu.import("resource://gre/modules/Services.jsm");

function fixup() {
  if (Services.vc.compare(Services.appinfo.version, "46.0a1") < 0) { // target <= 45
    if (Services.prefs.prefHasUserValue("network.http.accept-encoding.secure")) {
      // user has a local default - honor it and do nothing
      return;
    }

    // disable brotli and record that fact in the reverted pref
    Services.prefs.setCharPref("network.http.accept-encoding.secure", "gzip, deflate");
    Services.prefs.setBoolPref("network.http.accept-encoding.secure.reverted", true);

  } else { // re-enable
    if (Services.prefs.prefHasUserValue("network.http.accept-encoding.secure") &&
        Services.prefs.getBoolPref("network.http.accept-encoding.secure.reverted")) {
      Services.prefs.clearUserPref("network.http.accept-encoding.secure");
      Services.prefs.clearUserPref("network.http.accept-encoding.secure.reverted");
    }
  }
}

function shutdown(data, reason) {
}

function startup() {
  fixup();
}

function install() {
  fixup();
}

function uninstall() {
  if (Services.prefs.prefHasUserValue("network.http.accept-encoding.secure") &&
      Services.prefs.getBoolPref("network.http.accept-encoding.secure.reverted")) {
    Services.prefs.clearUserPref("network.http.accept-encoding.secure");
    Services.prefs.clearUserPref("network.http.accept-encoding.secure.reverted");
  }
}
